#include <iostream>
#include <string>
using namespace std;
int STEPS = 10000;
int main() {
	long long a, b, c;
	cin >> a >> b >> c;

	auto best = [&](int i) { return min(a * i, b + c * i); };

	// buy at step k
	auto test = [&](int k) {
		for(int i = 1; i <= STEPS; ++i) {
			auto cost = i <= k ? a * i : a * k + b + c * (i - k);
			if(cost > 2 * best(i)) return false;
		}
		return true;
	};

	int k = 0;
	for(; k <= STEPS; ++k) {
		if(test(k)) {
			break;
		}
	}

	long long i = 0;
	while(true) {
		string op;
		cin >> op;
		if(op == "end") break;
		if(i < k) {
			cout << "airline" << endl;
		} else if(i == k) {
			cout << "buy" << endl;
		} else {
			cout << "self" << endl;
		}
		i += 1;
	}
}
