#!/usr/bin/env python3
import random
import re


# Source: https://stackoverflow.com/a/48116944
def rot_90(blk):
    return [list(reversed(x)) for x in zip(*blk)]


random.seed(42)
h, w = map(int, input().split())
block = [list(input()) for _ in range(h)]
for _ in range(4):
    block = rot_90(block)
    if all(re.match(r"^#*\.*$", "".join(line)) for line in block):
        print(len(block[0]), len(block))
        print("\n".join(
            "".join("." if (c == "#") ^ (random.randint(0, 99) == 0) else "#" for c in line) for line in rot_90(block)))
        exit()
print("impossible")
