#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i,a,b) for(auto i=(a); i<(b); ++i)
#define REP(i,n) rep(i,0,n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template<class T> using min_queue =
priority_queue<T, vector<T>, greater<T>>;
template<class T> int sz(const T &x) {
    return (int) x.size(); // copy the ampersand(&)!
}

template<class T> ostream& operator<<(ostream &os, vector<T> &v) {
    os << "\n[";
    for(T &x : v) os << x << ',';
    return os << "]\n";
}

struct pairhash {
    public:
    template<typename T1, typename T2>
    size_t operator()(const pair<T1, T2> &p) const {
        size_t lhs = hash<T1>()(p.x);
        size_t rhs = hash<T2>()(p.y);
        return lhs ^ (rhs+0x9e3779b9+(lhs<<6)+(lhs>>2));
    }
};

void run() {
	ll n, L;
	cin >> n >> L;
	vi A, B;
	for (ll i = 0; i < n; i++) {
		string s;
		ll t;
		cin >> s >> t;
		if (s == "N") {
			A.pb(t);
		} else {
			B.pb(t);
		}
	}
	sort(all(A));
	sort(all(B));
	vvi TA(A.size()+1, vi(B.size()+1, 1'000'000'000'000'000));
	vvi TB(A.size()+1, vi(B.size()+1, 1'000'000'000'000'000));
	for (ll i = 0; i <= A.size(); i++) {
		for (ll j = 0; j <= B.size(); j++) {
			if (i == 0 && j == 0) {
				TA[i][j] = 0;
				TB[i][j] = 0;
				continue;
			}
			if (i > 0) TA[i][j] = max(TA[i-1][j], A[i-1]);
			if (j > 0) TB[i][j] = max(TB[i][j-1], B[j-1]);
			TA[i][j] = min(TA[i][j], TB[i][j] + L);
			TB[i][j] = min(TB[i][j], TA[i][j] + L);
		}
	}
	cout << min(TA[A.size()][B.size()]+L, TB[A.size()][B.size()]+L) << endl;
}

signed main() {
    // DON'T MIX "scanf" and "cin"!
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(20);
    run();
    return 0;
}
