import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class NickyEnMark {
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int n = scanner.nextInt();
		int r = scanner.nextInt();
		int[][] items = new int[2 * n][];
		for (int i = 0; i < 2 * n; i++) {
			items[i] = new int[r];
		}

		for (int i = 0; i < r; i++) {
			for (int j = 0; j < 2 * n; j++) {
				int k = scanner.nextInt();
				items[j][i] = k <= n ? 1 : 0;
			}
		}

		Arrays.sort(items, Comparator.comparing(Arrays::toString));

//		for (int j = 0; j < 2 * n; j++) {
//			System.out.println(Arrays.toString(items[j]));
//		}

		for (int i = 0; i < n; i++) {
			if (!Arrays.equals(items[i], reversed(items[2 * n - i - 1]))) {
				System.out.println("impossible");
				return;
			}
		}

		System.out.println("possible");
	}

	private static int[] reversed(int[] array) {
		int[] reversed = new int[array.length];
		for (int i = 0; i < array.length; i++) {
			reversed[i] = array[i] == 0 ? 1 : 0;
		}

		return reversed;
	}
}
