#!/usr/bin/python3

from math import sqrt

n = int(input())
cities = [[int(x) for x in input().split()] for _ in range(n)]

best_distance = 10**1000

for airport in cities:
    current_distance = 0
    for city in cities:
        current_distance += sqrt((airport[0] - city[0])**2 + (airport[1] - city[1])**2)
    best_distance = min(best_distance, current_distance)

print(best_distance / (n-1))
