#include <iostream>
#include <cmath>

using namespace std;

const int N = 1050;

int n;
int x[N];
int y[N];

int main() {
    cin >> n;

    long long tx = 0;
    long long ty = 0;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        tx += x[i];
        ty += y[i];
    }

    double ax = static_cast<double>(tx) / n;
    double ay = static_cast<double>(ty) / n;
    double total = 0;
    for (int j = 0; j < n; ++j) {
        double dx = x[j] - ax;
        double dy = y[j] - ay;
        total += sqrt(dx * dx + dy * dy);
    }
    cout.precision(10);
    cout << total / (n-1) << endl;
    return 0;
}
